Index: asp3_tinet_ecnl_rx/trunk/wolfssl-3.12.2/wolfcrypt/src/sha256.c
===================================================================
--- asp3_tinet_ecnl_rx/trunk/wolfssl-3.12.2/wolfcrypt/src/sha256.c	(revision 371)
+++ asp3_tinet_ecnl_rx/trunk/wolfssl-3.12.2/wolfcrypt/src/sha256.c	(revision 372)
@@ -792,270 +857,575 @@
 #if defined(HAVE_INTEL_AVX1) || defined(HAVE_INTEL_AVX2)
 
-#define _DigestToReg(S0, S1, S2, S3, S4, S5, S6, S7) \
-    "leaq	%[digest], %%r8\n\t"                 \
-    "movl	  (%%r8), %"#S0"\n\t"                \
-    "movl	 4(%%r8), %"#S1"\n\t"                \
-    "movl	 8(%%r8), %"#S2"\n\t"                \
-    "movl	12(%%r8), %"#S3"\n\t"                \
-    "movl	16(%%r8), %"#S4"\n\t"                \
-    "movl	20(%%r8), %"#S5"\n\t"                \
-    "movl	24(%%r8), %"#S6"\n\t"                \
-    "movl	28(%%r8), %"#S7"\n\t"
-
-#define _RegToDigest(S0, S1, S2, S3, S4, S5, S6, S7) \
-    "leaq	%[digest], %%r8\n\t"                 \
-    "addl %"#S0",   (%%r8)\n\t"                      \
-    "addl %"#S1",  4(%%r8)\n\t"                      \
-    "addl %"#S2",  8(%%r8)\n\t"                      \
-    "addl %"#S3", 12(%%r8)\n\t"                      \
-    "addl %"#S4", 16(%%r8)\n\t"                      \
-    "addl %"#S5", 20(%%r8)\n\t"                      \
-    "addl %"#S6", 24(%%r8)\n\t"                      \
-    "addl %"#S7", 28(%%r8)\n\t"
-
-#define DigestToReg(S_0, S_1, S_2, S_3, S_4, S_5, S_6, S_7 )\
-    _DigestToReg(S_0, S_1, S_2, S_3, S_4, S_5, S_6, S_7 )
-
-#define RegToDigest(S_0, S_1, S_2, S_3, S_4, S_5, S_6, S_7 )\
-    _RegToDigest(S_0, S_1, S_2, S_3, S_4, S_5, S_6, S_7 )
-
-
-#define S_0 %r15d
-#define S_1 %r10d
-#define S_2 %r11d
-#define S_3 %r12d
-#define S_4 %r13d
-#define S_5 %r14d
-#define S_6 %ebx
-#define S_7 %r9d
-
-#define SSE_REGs "%edi", "%esi", "%edx", "%ebx","%r8","%r9","%r10","%r11","%r12","%r13","%r14","%r15"
+#define _LOAD_DIGEST()                     \
+    "movl	  (%[sha256]), %%r8d \n\t" \
+    "movl	 4(%[sha256]), %%r9d \n\t" \
+    "movl	 8(%[sha256]), %%r10d\n\t" \
+    "movl	12(%[sha256]), %%r11d\n\t" \
+    "movl	16(%[sha256]), %%r12d\n\t" \
+    "movl	20(%[sha256]), %%r13d\n\t" \
+    "movl	24(%[sha256]), %%r14d\n\t" \
+    "movl	28(%[sha256]), %%r15d\n\t"
+
+#define _STORE_ADD_DIGEST()                \
+    "addl	%%r8d ,   (%[sha256])\n\t" \
+    "addl	%%r9d ,  4(%[sha256])\n\t" \
+    "addl	%%r10d,  8(%[sha256])\n\t" \
+    "addl	%%r11d, 12(%[sha256])\n\t" \
+    "addl	%%r12d, 16(%[sha256])\n\t" \
+    "addl	%%r13d, 20(%[sha256])\n\t" \
+    "addl	%%r14d, 24(%[sha256])\n\t" \
+    "addl	%%r15d, 28(%[sha256])\n\t"
+
+#define _ADD_DIGEST()                      \
+    "addl	  (%[sha256]), %%r8d \n\t" \
+    "addl	 4(%[sha256]), %%r9d \n\t" \
+    "addl	 8(%[sha256]), %%r10d\n\t" \
+    "addl	12(%[sha256]), %%r11d\n\t" \
+    "addl	16(%[sha256]), %%r12d\n\t" \
+    "addl	20(%[sha256]), %%r13d\n\t" \
+    "addl	24(%[sha256]), %%r14d\n\t" \
+    "addl	28(%[sha256]), %%r15d\n\t"
+
+#define _STORE_DIGEST()                    \
+    "movl	%%r8d ,   (%[sha256])\n\t" \
+    "movl	%%r9d ,  4(%[sha256])\n\t" \
+    "movl	%%r10d,  8(%[sha256])\n\t" \
+    "movl	%%r11d, 12(%[sha256])\n\t" \
+    "movl	%%r12d, 16(%[sha256])\n\t" \
+    "movl	%%r13d, 20(%[sha256])\n\t" \
+    "movl	%%r14d, 24(%[sha256])\n\t" \
+    "movl	%%r15d, 28(%[sha256])\n\t"
+
+#define LOAD_DIGEST() \
+    _LOAD_DIGEST()
+
+#define STORE_ADD_DIGEST() \
+    _STORE_ADD_DIGEST()
+
+#define ADD_DIGEST() \
+    _ADD_DIGEST()
+
+#define STORE_DIGEST() \
+    _STORE_DIGEST()
+
+
+#define S_0 %r8d
+#define S_1 %r9d
+#define S_2 %r10d
+#define S_3 %r11d
+#define S_4 %r12d
+#define S_5 %r13d
+#define S_6 %r14d
+#define S_7 %r15d
+
+#define L1  "%%edx"
+#define L2  "%%ecx"
+#define L3  "%%eax"
+#define L4  "%%ebx"
+#define WK  "%%rsp"
+
+#define WORK_REGS  "eax", "ebx", "ecx", "edx"
+#define STATE_REGS "r8","r9","r10","r11","r12","r13","r14","r15"
+#define XMM_REGS   "xmm0", "xmm1", "xmm2", "xmm3", "xmm4", "xmm5", "xmm6",    \
+                   "xmm7", "xmm8", "xmm9", "xmm10", "xmm11", "xmm12", "xmm13"
 
 #if defined(HAVE_INTEL_RORX)
-#define RND_STEP_RORX_1(a,b,c,d,e,f,g,h,i) \
-    "# edx = e>>>6\n\t"                    \
-    "rorx	$6, %"#e", %%edx\n\t"
-
-#define RND_STEP_RORX_2(a,b,c,d,e,f,g,h,i) \
-    "# edi = e>>>11\n\t"                   \
-    "rorx	$11, %"#e",%%edi\n\t"      \
-    "# edi = (e>>11) ^ (e>>6)\n\t"         \
-    "xorl	%%edx, %%edi\n\t"          \
-    "# edx = e>>>25\n\t"                   \
-    "rorx	$25, %"#e", %%edx\n\t"
-
-#define RND_STEP_RORX_3(a,b,c,d,e,f,g,h,i) \
-    "# esi = f\n\t"                        \
-    "movl	%"#f", %%esi\n\t"          \
-    "# esi = f ^ g\n\t"                    \
-    "xorl	%"#g", %%esi\n\t"          \
-    "# edx = Sigma1(e)\n\t"                \
-    "xorl	%%edi, %%edx\n\t"          \
-    "# esi = (f ^ g) & e\n\t"              \
-    "andl	%"#e", %%esi\n\t"          \
-    "# esi = Ch(e,f,g)\n\t"                \
-    "xorl	%"#g", %%esi\n\t"
-
-#define RND_STEP_RORX_4(a,b,c,d,e,f,g,h,i) \
-    "# h += w_k\n\t"                       \
-    "leaq	%[W_K], %%r8\n\t"          \
-    "addl	("#i")*4(%%r8), %"#h"\n\t" \
-    "# h = h + w_k + Sigma1(e)\n\t"        \
-    "addl	%%edx, %"#h"\n\t"          \
-    "# r8d = a>>>2\n\t"                    \
-    "rorx	$2, %"#a", %%r8d\n\t"      \
-    "# edi = a>>>13\n\t"                   \
-    "rorx	$13, %"#a", %%edi\n\t"
-
-#define RND_STEP_RORX_5(a,b,c,d,e,f,g,h,i) \
-    "# edx = a>>22\n\t"                    \
-    "rorx	$22, %"#a", %%edx\n\t"     \
-    "# edi = (a>>>2) ^ (a>>>13)\n\t"       \
-    "xorl	%%r8d, %%edi\n\t"          \
-    "# edx = Sigma0(a)\n\t"                \
-    "xorl	%%edi, %%edx\n\t"
-
-#define RND_STEP_RORX_6(a,b,c,d,e,f,g,h,i) \
-    "# edi = b\n\t"                        \
-    "movl	%"#b", %%edi\n\t"          \
-    "# edi = a | b\n\t"                    \
-    "orl	%"#a", %%edi\n\t"          \
-    "# edi = (a | b) & c\n\t"              \
-    "andl	%"#c", %%edi\n\t"          \
-    "# r8d = b\n\t"                        \
-    "movl	%"#b", %%r8d\n\t"
-
-#define RND_STEP_RORX_7(a,b,c,d,e,f,g,h,i) \
-    "# h += Ch(e,f,g)\n\t"                 \
-    "addl	%%esi, %"#h"\n\t"          \
-    "# r8d = b & a\n\t"                    \
-    "andl	%"#a", %%r8d\n\t"          \
-    "# r8d = Maj(a,b,c)\n\t"               \
-    "orl	%%edi, %%r8d\n\t"
-
-#define RND_STEP_RORX_8(a,b,c,d,e,f,g,h,i)       \
-    "# d += h + w_k + Sigma1(e) + Ch(e,f,g)\n\t" \
+#define RND_STEP_RORX_0_1(a, b, c, d, e, f, g, h, i) \
+    /* L3 = f */                                     \
+    "movl	%" #f ", " L3 "\n\t"                 \
+    /* L2 = e>>>11 */                                \
+    "rorx	$11, %" #e ", " L2 "\n\t"            \
+    /* h += w_k */                                   \
+    "addl	(" #i ")*4(" WK "), %" #h "\n\t"     \
+
+#define RND_STEP_RORX_0_2(a, b, c, d, e, f, g, h, i) \
+    /* L2 = (e>>>6) ^ (e>>>11) */                    \
+    "xorl	" L1 ", " L2 "\n\t"                  \
+    /* L3 = f ^ g */                                 \
+    "xorl	%" #g ", " L3 "\n\t"                 \
+    /* L1 = e>>>25 */                                \
+    "rorx	$25, %" #e ", " L1 "\n\t"            \
+
+#define RND_STEP_RORX_0_3(a, b, c, d, e, f, g, h, i) \
+    /* L3 = (f ^ g) & e */                           \
+    "andl	%" #e ", " L3 "\n\t"                 \
+    /* L1 = Sigma1(e) */                             \
+    "xorl	" L2 ", " L1 "\n\t"                  \
+    /* L2 = a>>>13 */                                \
+    "rorx	$13, %" #a ", " L2 "\n\t"            \
+
+#define RND_STEP_RORX_0_4(a, b, c, d, e, f, g, h, i) \
+    /* h += Sigma1(e) */                             \
+    "addl	" L1 ", %" #h "\n\t"                 \
+    /* L1 = a>>>2 */                                 \
+    "rorx	$2, %" #a ", " L1 "\n\t"             \
+    /* L3 = Ch(e,f,g) */                             \
+    "xorl	%" #g ", " L3 "\n\t"                 \
+
+#define RND_STEP_RORX_0_5(a, b, c, d, e, f, g, h, i) \
+    /* L2 = (a>>>2) ^ (a>>>13) */                    \
+    "xorl	" L1 ", " L2 "\n\t"                  \
+    /* L1 = a>>>22 */                                \
+    "rorx	$22, %" #a ", " L1 "\n\t"            \
+    /* h += Ch(e,f,g) */                             \
+    "addl	" L3 ", %" #h "\n\t"                 \
+
+#define RND_STEP_RORX_0_6(a, b, c, d, e, f, g, h, i) \
+    /* L1 = Sigma0(a) */                             \
+    "xorl	" L2 ", " L1 "\n\t"                  \
+    /* L3 = b */                                     \
+    "movl	%" #b ", " L3 "\n\t"                 \
+    /* d += h + w_k + Sigma1(e) + Ch(e,f,g) */       \
+    "addl	%" #h ", %" #d "\n\t"                \
+
+#define RND_STEP_RORX_0_7(a, b, c, d, e, f, g, h, i) \
+    /* L3 = a ^ b */                                 \
+    "xorl	%" #a ", " L3 "\n\t"                 \
+    /* h += Sigma0(a) */                             \
+    "addl	" L1 ", %" #h "\n\t"                 \
+    /* L4 = (a ^ b) & (b ^ c) */                     \
+    "andl	" L3 ", " L4 "\n\t"                  \
+
+#define RND_STEP_RORX_0_8(a, b, c, d, e, f, g, h, i) \
+    /* L4 = Maj(a,b,c) */                            \
+    "xorl	%" #b ", " L4 "\n\t"                 \
+    /* L1 = d>>>6 (= e>>>6 next RND) */              \
+    "rorx	$6, %" #d ", " L1 "\n\t"             \
+    /* h += Maj(a,b,c) */                            \
+    "addl	" L4 ", %" #h "\n\t"                 \
+
+#define RND_STEP_RORX_1_1(a, b, c, d, e, f, g, h, i) \
+    /* L4 = f */                                     \
+    "movl	%" #f ", " L4 "\n\t"                 \
+    /* L2 = e>>>11 */                                \
+    "rorx	$11, %" #e ", " L2 "\n\t"            \
+    /* h += w_k */                                   \
+    "addl	(" #i ")*4(" WK "), %" #h "\n\t"     \
+
+#define RND_STEP_RORX_1_2(a, b, c, d, e, f, g, h, i) \
+    /* L2 = (e>>>6) ^ (e>>>11) */                    \
+    "xorl	" L1 ", " L2 "\n\t"                  \
+    /* L4 = f ^ g */                                 \
+    "xorl	%" #g ", " L4 "\n\t"                 \
+    /* L1 = e>>>25 */                                \
+    "rorx	$25, %" #e ", " L1 "\n\t"            \
+
+#define RND_STEP_RORX_1_3(a, b, c, d, e, f, g, h, i) \
+    /* L4 = (f ^ g) & e */                           \
+    "andl	%" #e ", " L4 "\n\t"                 \
+    /* L1 = Sigma1(e) */                             \
+    "xorl	" L2 ", " L1 "\n\t"                  \
+    /* L2 = a>>>13 */                                \
+    "rorx	$13, %" #a ", " L2 "\n\t"            \
+
+#define RND_STEP_RORX_1_4(a, b, c, d, e, f, g, h, i) \
+    /* h += Sigma1(e) */                             \
+    "addl	" L1 ", %" #h "\n\t"                 \
+    /* L1 = a>>>2 */                                 \
+    "rorx	$2, %" #a ", " L1 "\n\t"             \
+    /* L4 = Ch(e,f,g) */                             \
+    "xorl	%" #g ", " L4 "\n\t"                 \
+
+#define RND_STEP_RORX_1_5(a, b, c, d, e, f, g, h, i) \
+    /* L2 = (a>>>2) ^ (a>>>13) */                    \
+    "xorl	" L1 ", " L2 "\n\t"                  \
+    /* L1 = a>>>22 */                                \
+    "rorx	$22, %" #a ", " L1 "\n\t"            \
+    /* h += Ch(e,f,g) */                             \
+    "addl	" L4 ", %" #h "\n\t"                 \
+
+#define RND_STEP_RORX_1_6(a, b, c, d, e, f, g, h, i) \
+    /* L1 = Sigma0(a) */                             \
+    "xorl	" L2 ", " L1 "\n\t"                  \
+    /* L4 = b */                                     \
+    "movl	%" #b ", " L4 "\n\t"                 \
+    /* d += h + w_k + Sigma1(e) + Ch(e,f,g) */       \
     "addl	%"#h", %"#d"\n\t"                \
-    "addl	%"#h", %%r8d\n\t"                \
-    "addl	%%edx, %%r8d\n\t"                \
-    "movl	%%r8d, %"#h"\n\t"
+
+#define RND_STEP_RORX_1_7(a, b, c, d, e, f, g, h, i) \
+    /* L4 = a ^ b */                                 \
+    "xorl	%" #a ", " L4 "\n\t"                 \
+    /* h += Sigma0(a) */                             \
+    "addl	" L1 ", %" #h "\n\t"                 \
+    /* L3 = (a ^ b) & (b ^ c) */                     \
+    "andl	" L4 ", " L3 "\n\t"                  \
+
+#define RND_STEP_RORX_1_8(a, b, c, d, e, f, g, h, i) \
+    /* L3 = Maj(a,b,c) */                            \
+    "xorl	%" #b ", " L3 "\n\t"                 \
+    /* L1 = d>>>6 (= e>>>6 next RND) */              \
+    "rorx	$6, %" #d ", " L1 "\n\t"             \
+    /* h += Maj(a,b,c) */                            \
+    "addl	" L3 ", %" #h "\n\t"                 \
+
+#define _RND_RORX_X_0(a, b, c, d, e, f, g, h, i)     \
+    /* L1 = e>>>6 */                                 \
+    "rorx	$6, %" #e ", " L1 "\n\t"             \
+    /* L2 = e>>>11 */                                \
+    "rorx	$11, %" #e ", " L2 "\n\t"            \
+    /* Prev RND: h += Maj(a,b,c) */                  \
+    "addl	" L3 ", %" #a "\n\t"                 \
+    /* h += w_k */                                   \
+    "addl	(" #i ")*4(" WK "), %" #h "\n\t"     \
+    /* L3 = f */                                     \
+    "movl	%" #f ", " L3 "\n\t"                 \
+    /* L2 = (e>>>6) ^ (e>>>11) */                    \
+    "xorl	" L1 ", " L2 "\n\t"                  \
+    /* L3 = f ^ g */                                 \
+    "xorl	%" #g ", " L3 "\n\t"                 \
+    /* L1 = e>>>25 */                                \
+    "rorx	$25, %" #e ", " L1 "\n\t"            \
+    /* L1 = Sigma1(e) */                             \
+    "xorl	" L2 ", " L1 "\n\t"                  \
+    /* L3 = (f ^ g) & e */                           \
+    "andl	%" #e ", " L3 "\n\t"                 \
+    /* h += Sigma1(e) */                             \
+    "addl	" L1 ", %" #h "\n\t"                 \
+    /* L1 = a>>>2 */                                 \
+    "rorx	$2, %" #a ", " L1 "\n\t"             \
+    /* L2 = a>>>13 */                                \
+    "rorx	$13, %" #a ", " L2 "\n\t"            \
+    /* L3 = Ch(e,f,g) */                             \
+    "xorl	%" #g ", " L3 "\n\t"                 \
+    /* L2 = (a>>>2) ^ (a>>>13) */                    \
+    "xorl	" L1 ", " L2 "\n\t"                  \
+    /* L1 = a>>>22 */                                \
+    "rorx	$22, %" #a ", " L1 "\n\t"            \
+    /* h += Ch(e,f,g) */                             \
+    "addl	" L3 ", %" #h "\n\t"                 \
+    /* L1 = Sigma0(a) */                             \
+    "xorl	" L2 ", " L1 "\n\t"                  \
+    /* L3 = b */                                     \
+    "movl	%" #b ", " L3 "\n\t"                 \
+    /* d += h + w_k + Sigma1(e) + Ch(e,f,g) */       \
+    "addl	%" #h ", %" #d "\n\t"                \
+    /* L3 = a ^ b */                                 \
+    "xorl	%" #a ", " L3 "\n\t"                 \
+    /* L4 = (a ^ b) & (b ^ c) */                     \
+    "andl	" L3 ", " L4 "\n\t"                  \
+    /* h += Sigma0(a) */                             \
+    "addl	" L1 ", %" #h "\n\t"                 \
+    /* L4 = Maj(a,b,c) */                            \
+    "xorl	%" #b ", " L4 "\n\t"                 \
+
+#define _RND_RORX_X_1(a, b, c, d, e, f, g, h, i)     \
+    /* L1 = e>>>6 */                                 \
+    "rorx	$6, %" #e ", " L1 "\n\t"             \
+    /* L2 = e>>>11 */                                \
+    "rorx	$11, %" #e ", " L2 "\n\t"            \
+    /* Prev RND: h += Maj(a,b,c) */                  \
+    "addl	" L4 ", %" #a "\n\t"                 \
+    /* h += w_k */                                   \
+    "addl	(" #i ")*4(" WK "), %" #h "\n\t"     \
+    /* L4 = f */                                     \
+    "movl	%" #f ", " L4 "\n\t"                 \
+    /* L2 = (e>>>6) ^ (e>>>11) */                    \
+    "xorl	" L1 ", " L2 "\n\t"                  \
+    /* L4 = f ^ g */                                 \
+    "xorl	%" #g ", " L4 "\n\t"                 \
+    /* L1 = e>>>25 */                                \
+    "rorx	$25, %" #e ", " L1 "\n\t"            \
+    /* L1 = Sigma1(e) */                             \
+    "xorl	" L2 ", " L1 "\n\t"                  \
+    /* L4 = (f ^ g) & e */                           \
+    "andl	%" #e ", " L4 "\n\t"                 \
+    /* h += Sigma1(e) */                             \
+    "addl	" L1 ", %" #h "\n\t"                 \
+    /* L1 = a>>>2 */                                 \
+    "rorx	$2, %" #a ", " L1 "\n\t"             \
+    /* L2 = a>>>13 */                                \
+    "rorx	$13, %" #a ", " L2 "\n\t"            \
+    /* L4 = Ch(e,f,g) */                             \
+    "xorl	%" #g ", " L4 "\n\t"                 \
+    /* L2 = (a>>>2) ^ (a>>>13) */                    \
+    "xorl	" L1 ", " L2 "\n\t"                  \
+    /* L1 = a>>>22 */                                \
+    "rorx	$22, %" #a ", " L1 "\n\t"            \
+    /* h += Ch(e,f,g) */                             \
+    "addl	" L4 ", %" #h "\n\t"                 \
+    /* L1 = Sigma0(a) */                             \
+    "xorl	" L2 ", " L1 "\n\t"                  \
+    /* L4 = b */                                     \
+    "movl	%" #b ", " L4 "\n\t"                 \
+    /* d += h + w_k + Sigma1(e) + Ch(e,f,g) */       \
+    "addl	%" #h ", %" #d "\n\t"                \
+    /* L4 = a ^ b */                                 \
+    "xorl	%" #a ", " L4 "\n\t"                 \
+    /* L2 = (a ^ b) & (b ^ c) */                     \
+    "andl	" L4 ", " L3 "\n\t"                  \
+    /* h += Sigma0(a) */                             \
+    "addl	" L1 ", %" #h "\n\t"                 \
+    /* L3 = Maj(a,b,c) */                            \
+    "xorl	%" #b ", " L3 "\n\t"                 \
+
+
+#define RND_RORX_X_0(a,b,c,d,e,f,g,h,i) \
+       _RND_RORX_X_0(a,b,c,d,e,f,g,h,i)
+#define RND_RORX_X_1(a,b,c,d,e,f,g,h,i) \
+       _RND_RORX_X_1(a,b,c,d,e,f,g,h,i)
+
+#define RND_RORX_X4(a,b,c,d,e,f,g,h,i)    \
+        RND_RORX_X_0(a,b,c,d,e,f,g,h,i+0) \
+        RND_RORX_X_1(h,a,b,c,d,e,f,g,i+1) \
+        RND_RORX_X_0(g,h,a,b,c,d,e,f,i+2) \
+        RND_RORX_X_1(f,g,h,a,b,c,d,e,i+3)
+
 #endif /* HAVE_INTEL_RORX */
 
-#define RND_STEP_1(a,b,c,d,e,f,g,h,i) \
-    "movl	%"#e", %%edx\n\t"     \
-    "# edx = e>>>6\n\t"               \
-    "roll	$26, %%edx\n\t"       \
-    "movl	%"#e", %%edi\n\t"
-
-#define RND_STEP_2(a,b,c,d,e,f,g,h,i) \
-    "# edi = e>>>11\n\t"              \
-    "roll	$21, %%edi\n\t"       \
-    "# edi = (e>>11) ^ (e>>6)\n\t"    \
-    "xorl	%%edx, %%edi\n\t"     \
-    "# edx = e\n\t"                   \
-    "movl	%"#e", %%edx\n\t"     \
-    "# edx = e>>>25\n\t"              \
-    "roll	$7, %%edx\n\t"
-
-#define RND_STEP_3(a,b,c,d,e,f,g,h,i) \
-    "# esi = f\n\t"                   \
-    "movl	%"#f", %%esi\n\t"     \
-    "# esi = f ^ g\n\t"               \
-    "xorl	%"#g", %%esi\n\t"     \
-    "# edx = Sigma1(e)\n\t"           \
-    "xorl	%%edi, %%edx\n\t"     \
-    "# esi = (f ^ g) & e\n\t"         \
-    "andl	%"#e", %%esi\n\t"     \
-    "# esi = Ch(e,f,g)\n\t"           \
-    "xorl	%"#g", %%esi\n\t"
-
-#define RND_STEP_4(a,b,c,d,e,f,g,h,i)      \
-    "# h += w_k\n\t"                       \
-    "leaq	%[W_K], %%r8\n\t"          \
-    "addl	("#i")*4(%%r8), %"#h"\n\t" \
-    "# h = h + w_k + Sigma1(e)\n\t"        \
-    "addl	%%edx, %"#h"\n\t"          \
-    "# r8d = a\n\t"                        \
-    "movl	%"#a", %%r8d\n\t"          \
-    "# r8d = a>>>2\n\t"                    \
-    "roll	$30, %%r8d\n\t"            \
-    "# edi = a\n\t"                        \
-    "movl	%"#a", %%edi\n\t"          \
-    "# edi = a>>>13\n\t"                   \
-    "roll	$19, %%edi\n\t"            \
-    "# edx = a\n\t"                        \
-    "movl	%"#a", %%edx\n\t"
-
-#define RND_STEP_5(a,b,c,d,e,f,g,h,i) \
-    "# edx = a>>>22\n\t"              \
-    "roll	$10, %%edx\n\t"       \
-    "# edi = (a>>>2) ^ (a>>>13)\n\t"  \
-    "xorl	%%r8d, %%edi\n\t"     \
-    "# edx = Sigma0(a)\n\t"           \
-    "xorl	%%edi, %%edx\n\t"
-
-#define RND_STEP_6(a,b,c,d,e,f,g,h,i) \
-    "# edi = b\n\t"                   \
-    "movl	%"#b", %%edi\n\t"     \
-    "# edi = a | b\n\t"               \
-    "orl	%"#a", %%edi\n\t"     \
-    "# edi = (a | b) & c\n\t"         \
-    "andl	%"#c", %%edi\n\t"     \
-    "# r8d = b\n\t"                   \
-    "movl	%"#b", %%r8d\n\t"
-
-#define RND_STEP_7(a,b,c,d,e,f,g,h,i) \
-    "# h += Ch(e,f,g)\n\t"            \
-    "addl	%%esi, %"#h"\n\t"     \
-    "#r8d = b & a\n\t"                \
-    "andl	%"#a", %%r8d\n\t"     \
-    "# r8d = Maj(a,b,c)\n\t"          \
-    "orl	%%edi, %%r8d\n\t"
-
-#define RND_STEP_8(a,b,c,d,e,f,g,h,i)                                    \
-    "# d += h + w_k + Sigma1(e) + Ch(e,f,g)\n\t"                         \
+#define RND_STEP_0_1(a,b,c,d,e,f,g,h,i)                               \
+    /* L1 = e>>>14 */                                                 \
+    "rorl	$14, " L1 "\n\t"                                      \
+
+#define RND_STEP_0_2(a,b,c,d,e,f,g,h,i)                               \
+    /* L3 = b */                                                      \
+    "movl	%" #b ", " L3 "\n\t"                                  \
+    /* L2 = f */                                                      \
+    "movl	%" #f ", " L2 "\n\t"                                  \
+    /* h += w_k */                                                    \
+    "addl	(" #i ")*4(" WK "), %" #h "\n\t"                      \
+    /* L2 = f ^ g */                                                  \
+    "xorl	%" #g ", " L2 "\n\t"                                  \
+
+#define RND_STEP_0_3(a,b,c,d,e,f,g,h,i)                               \
+    /* L1 = (e>>>14) ^ e */                                           \
+    "xorl	%" #e ", " L1 "\n\t"                                  \
+    /* L2 = (f ^ g) & e */                                            \
+    "andl	%" #e ", " L2 "\n\t"                                  \
+
+#define RND_STEP_0_4(a,b,c,d,e,f,g,h,i)                               \
+    /* L1 = ((e>>>14) ^ e) >>> 5 */                                   \
+    "rorl	$5, " L1 "\n\t"                                       \
+    /* L2 = Ch(e,f,g) */                                              \
+    "xorl	%" #g ", " L2 "\n\t"                                  \
+    /* L1 = (((e>>>14) ^ e) >>> 5) ^ e */                             \
+    "xorl	%" #e ", " L1 "\n\t"                                  \
+    /* h += Ch(e,f,g) */                                              \
+    "addl	" L2 ", %" #h "\n\t"                                  \
+
+#define RND_STEP_0_5(a,b,c,d,e,f,g,h,i)                               \
+    /* L1 = ((((e>>>14) ^ e) >>> 5) ^ e) >>> 6 */                     \
+    "rorl	$6, " L1 "\n\t"                                       \
+    /* L3 = a ^ b (= b ^ c of next RND) */                            \
+    "xorl	%" #a ", " L3 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) */                                     \
+    "addl	" L1 ", %" #h "\n\t"                                  \
+    /* L2 = a */                                                      \
+    "movl	%" #a ", " L2 "\n\t"                                  \
+
+#define RND_STEP_0_6(a,b,c,d,e,f,g,h,i)                               \
+    /* L3 = (a ^ b) & (b ^ c) */                                      \
+    "andl	" L3 ", " L4 "\n\t"                                   \
+    /* L2 = a>>>9 */                                                  \
+    "rorl	$9, " L2 "\n\t"                                       \
+    /* L2 = (a>>>9) ^ a */                                            \
+    "xorl	%" #a ", " L2 "\n\t"                                  \
+    /* L1 = Maj(a,b,c) */                                             \
+    "xorl	%" #b ", " L4 "\n\t"                                  \
+
+#define RND_STEP_0_7(a,b,c,d,e,f,g,h,i)                               \
+    /* L2 = ((a>>>9) ^ a) >>> 11 */                                   \
+    "rorl	$11, " L2 "\n\t"                                      \
+    /* d += h + w_k + Sigma1(e) + Ch(e,f,g) */                        \
+    "addl	%" #h ", %" #d "\n\t"                                 \
+    /* L2 = (((a>>>9) ^ a) >>> 11) ^ a */                             \
+    "xorl	%" #a ", " L2 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) + Ch(e,f,g) + Maj(a,b,c) */            \
+    "addl	" L4 ", %" #h "\n\t"                                  \
+
+#define RND_STEP_0_8(a,b,c,d,e,f,g,h,i)                               \
+    /* L2 = ((((a>>>9) ^ a) >>> 11) ^ a) >>> 2 */                     \
+    "rorl	$2, " L2 "\n\t"                                       \
+    /* L1 = d (e of next RND) */                                      \
+    "movl	%" #d ", " L1 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) Sigma0(a) + Ch(e,f,g) + Maj(a,b,c) */  \
+    "addl	" L2 ", %" #h "\n\t"                                  \
+
+#define RND_STEP_1_1(a,b,c,d,e,f,g,h,i)                               \
+    /* L1 = e>>>14 */                                                 \
+    "rorl	$14, " L1 "\n\t"                                      \
+
+#define RND_STEP_1_2(a,b,c,d,e,f,g,h,i)                               \
+    /* L3 = b */                                                      \
+    "movl	%" #b ", " L4 "\n\t"                                  \
+    /* L2 = f */                                                      \
+    "movl	%" #f ", " L2 "\n\t"                                  \
+    /* h += w_k */                                                    \
+    "addl	(" #i ")*4(" WK "), %" #h "\n\t"                      \
+    /* L2 = f ^ g */                                                  \
+    "xorl	%" #g ", " L2 "\n\t"                                  \
+
+#define RND_STEP_1_3(a,b,c,d,e,f,g,h,i)                               \
+    /* L1 = (e>>>14) ^ e */                                           \
+    "xorl	%" #e ", " L1 "\n\t"                                  \
+    /* L2 = (f ^ g) & e */                                            \
+    "andl	%" #e ", " L2 "\n\t"                                  \
+
+#define RND_STEP_1_4(a,b,c,d,e,f,g,h,i)                               \
+    /* L1 = ((e>>>14) ^ e) >>> 5 */                                   \
+    "rorl	$5, " L1 "\n\t"                                       \
+    /* L2 = Ch(e,f,g) */                                              \
+    "xorl	%" #g ", " L2 "\n\t"                                  \
+    /* L1 = (((e>>>14) ^ e) >>> 5) ^ e */                             \
+    "xorl	%" #e ", " L1 "\n\t"                                  \
+    /* h += Ch(e,f,g) */                                              \
+    "addl	" L2 ", %" #h "\n\t"                                  \
+
+#define RND_STEP_1_5(a,b,c,d,e,f,g,h,i)                               \
+    /* L1 = ((((e>>>14) ^ e) >>> 5) ^ e) >>> 6 */                     \
+    "rorl	$6, " L1 "\n\t"                                       \
+    /* L4 = a ^ b (= b ^ c of next RND) */                            \
+    "xorl	%" #a ", " L4 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) */                                     \
+    "addl	" L1 ", %" #h "\n\t"                                  \
+    /* L2 = a */                                                      \
+    "movl	%" #a ", " L2 "\n\t"                                  \
+
+#define RND_STEP_1_6(a,b,c,d,e,f,g,h,i)                               \
+    /* L3 = (a ^ b) & (b ^ c)  */                                     \
+    "andl	" L4 ", " L3 "\n\t"                                   \
+    /* L2 = a>>>9 */                                                  \
+    "rorl	$9, " L2 "\n\t"                                       \
+    /* L2 = (a>>>9) ^ a */                                            \
+    "xorl	%" #a ", " L2 "\n\t"                                  \
+    /* L1 = Maj(a,b,c) */                                             \
+    "xorl	%" #b ", " L3 "\n\t"                                  \
+
+#define RND_STEP_1_7(a,b,c,d,e,f,g,h,i)                               \
+    /* L2 = ((a>>>9) ^ a) >>> 11 */                                   \
+    "rorl	$11, " L2 "\n\t"                                      \
+    /* d += h + w_k + Sigma1(e) + Ch(e,f,g) */                        \
+    "addl	%" #h ", %" #d "\n\t"                                 \
+    /* L2 = (((a>>>9) ^ a) >>> 11) ^ a */                             \
+    "xorl	%" #a ", " L2 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) + Ch(e,f,g) + Maj(a,b,c) */            \
+    "addl	" L3 ", %" #h "\n\t"                                  \
+
+#define RND_STEP_1_8(a,b,c,d,e,f,g,h,i)                               \
+    /* L2 = ((((a>>>9) ^ a) >>> 11) ^ a) >>> 2 */                     \
+    "rorl	$2, " L2 "\n\t"                                       \
+    /* L1 = d (e of next RND) */                                      \
+    "movl	%" #d ", " L1 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) Sigma0(a) + Ch(e,f,g) + Maj(a,b,c) */  \
+    "addl	" L2 ", %" #h "\n\t"                                  \
+
+#define _RND_ALL_0(a,b,c,d,e,f,g,h,i)                                 \
+    /* h += w_k */                                                    \
+    "addl	(" #i ")*4(" WK "), %" #h "\n\t"                      \
+    /* L2 = f */                                                      \
+    "movl	%" #f ", " L2 "\n\t"                                  \
+    /* L3 = b */                                                      \
+    "movl	%" #b ", " L3 "\n\t"                                  \
+    /* L2 = f ^ g */                                                  \
+    "xorl	%" #g ", " L2 "\n\t"                                  \
+    /* L1 = e>>>14 */                                                 \
+    "rorl	$14, " L1 "\n\t"                                      \
+    /* L2 = (f ^ g) & e */                                            \
+    "andl	%" #e ", " L2 "\n\t"                                  \
+    /* L1 = (e>>>14) ^ e */                                           \
+    "xorl	%" #e ", " L1 "\n\t"                                  \
+    /* L2 = Ch(e,f,g) */                                              \
+    "xorl	%" #g ", " L2 "\n\t"                                  \
+    /* L1 = ((e>>>14) ^ e) >>> 5 */                                   \
+    "rorl	$5, " L1 "\n\t"                                       \
+    /* h += Ch(e,f,g) */                                              \
+    "addl	" L2 ", %" #h "\n\t"                                  \
+    /* L1 = (((e>>>14) ^ e) >>> 5) ^ e */                             \
+    "xorl	%" #e ", " L1 "\n\t"                                  \
+    /* L3 = a ^ b */                                                  \
+    "xorl	%" #a ", " L3 "\n\t"                                  \
+    /* L1 = ((((e>>>14) ^ e) >>> 5) ^ e) >>> 6 */                     \
+    "rorl	$6, " L1 "\n\t"                                       \
+    /* L2 = a */                                                      \
+    "movl	%" #a ", " L2 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) */                                     \
+    "addl	" L1 ", %" #h "\n\t"                                  \
+    /* L2 = a>>>9 */                                                  \
+    "rorl	$9, " L2 "\n\t"                                       \
+    /* L3 = (a ^ b) & (b ^ c) */                                      \
+    "andl	" L3 ", " L4 "\n\t"                                   \
+    /* L2 = (a>>>9) ^ a */                                            \
+    "xorl	%" #a ", " L2 "\n\t"                                  \
+    /* L1 = Maj(a,b,c) */                                             \
+    "xorl	%" #b ", " L4 "\n\t"                                  \
+    /* L2 = ((a>>>9) ^ a) >>> 11 */                                   \
+    "rorl	$11, " L2 "\n\t"                                      \
+    /* d += h + w_k + Sigma1(e) + Ch(e,f,g) */                        \
+    "addl	%" #h ", %" #d "\n\t"                                 \
+    /* L2 = (((a>>>9) ^ a) >>> 11) ^ a */                             \
+    "xorl	%" #a ", " L2 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) + Ch(e,f,g) + Maj(a,b,c) */            \
+    "addl	" L4 ", %" #h "\n\t"                                  \
+    /* L2 = ((((a>>>9) ^ a) >>> 11) ^ a) >>> 2 */                     \
+    "rorl	$2, " L2 "\n\t"                                       \
+    /* L1 = d (e of next RND) */                                      \
+    "movl	%" #d ", " L1 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) Sigma0(a) + Ch(e,f,g) + Maj(a,b,c) */  \
+    "addl	" L2 ", %" #h "\n\t"                                  \
+
+#define _RND_ALL_1(a,b,c,d,e,f,g,h,i)                                 \
+    /* h += w_k */                                                    \
+    "addl	(" #i ")*4(" WK "), %" #h "\n\t"                      \
+    /* L2 = f */                                                      \
+    "movl	%" #f ", " L2 "\n\t"                                  \
+    /* L3 = b */                                                      \
+    "movl	%" #b ", " L4 "\n\t"                                  \
+    /* L2 = f ^ g */                                                  \
+    "xorl	%" #g ", " L2 "\n\t"                                  \
+    /* L1 = e>>>14 */                                                 \
+    "rorl	$14, " L1 "\n\t"                                      \
+    /* L2 = (f ^ g) & e */                                            \
+    "andl	%" #e ", " L2 "\n\t"                                  \
+    /* L1 = (e>>>14) ^ e */                                           \
+    "xorl	%" #e ", " L1 "\n\t"                                  \
+    /* L2 = Ch(e,f,g) */                                              \
+    "xorl	%" #g ", " L2 "\n\t"                                  \
+    /* L1 = ((e>>>14) ^ e) >>> 5 */                                   \
+    "rorl	$5, " L1 "\n\t"                                       \
+    /* h += Ch(e,f,g) */                                              \
+    "addl	" L2 ", %" #h "\n\t"                                  \
+    /* L1 = (((e>>>14) ^ e) >>> 5) ^ e */                             \
+    "xorl	%" #e ", " L1 "\n\t"                                  \
+    /* L3 = a ^ b */                                                  \
+    "xorl	%" #a ", " L4 "\n\t"                                  \
+    /* L1 = ((((e>>>14) ^ e) >>> 5) ^ e) >>> 6 */                     \
+    "rorl	$6, " L1 "\n\t"                                       \
+    /* L2 = a */                                                      \
+    "movl	%" #a ", " L2 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) */                                     \
+    "addl	" L1 ", %" #h "\n\t"                                  \
+    /* L2 = a>>>9 */                                                  \
+    "rorl	$9, " L2 "\n\t"                                       \
+    /* L3 = (a ^ b) & (b ^ c)  */                                     \
+    "andl	" L4 ", " L3 "\n\t"                                   \
+    /* L2 = (a>>>9) ^ a */                                            \
+    "xorl	%" #a", " L2 "\n\t"                                   \
+    /* L1 = Maj(a,b,c) */                                             \
+    "xorl	%" #b ", " L3 "\n\t"                                  \
+    /* L2 = ((a>>>9) ^ a) >>> 11 */                                   \
+    "rorl	$11, " L2 "\n\t"                                      \
+    /* d += h + w_k + Sigma1(e) + Ch(e,f,g) */                        \
     "addl	%"#h", %"#d"\n\t"                                        \
-    "# r8b = h + w_k + Sigma1(e) + Ch(e,f,g) + Maj(a,b,c)\n\t"           \
-    "addl	%"#h", %%r8d\n\t"                                        \
-    "# r8b = h + w_k + Sigma1(e) Sigma0(a) + Ch(e,f,g) + Maj(a,b,c)\n\t" \
-    "addl	%%edx, %%r8d\n\t"                                        \
-    "# h = h + w_k + Sigma1(e) + Sigma0(a) + Ch(e,f,g) + Maj(a,b,c)\n\t" \
-    "movl	%%r8d, %"#h"\n\t"
-
-#define RND_X(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_1(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_2(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_3(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_4(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_5(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_6(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_7(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_8(a,b,c,d,e,f,g,h,i)
-
-#define RND_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i)
-#define RND_7(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_7,S_0,S_1,S_2,S_3,S_4,S_5,S_6,_i)
-#define RND_6(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_6,S_7,S_0,S_1,S_2,S_3,S_4,S_5,_i)
-#define RND_5(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_5,S_6,S_7,S_0,S_1,S_2,S_3,S_4,_i)
-#define RND_4(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_4,S_5,S_6,S_7,S_0,S_1,S_2,S_3,_i)
-#define RND_3(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_3,S_4,S_5,S_6,S_7,S_0,S_1,S_2,_i)
-#define RND_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_2,S_3,S_4,S_5,S_6,S_7,S_0,S_1,_i)
-#define RND_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_1,S_2,S_3,S_4,S_5,S_6,S_7,S_0,_i)
-
-
-#define RND_1_3(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_1(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_2(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_3(a,b,c,d,e,f,g,h,i)
-
-#define RND_4_6(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_4(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_5(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_6(a,b,c,d,e,f,g,h,i)
-
-#define RND_7_8(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_7(a,b,c,d,e,f,g,h,i) \
-       RND_STEP_8(a,b,c,d,e,f,g,h,i)
-
-#define RND_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i)
-#define RND_7(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_7,S_0,S_1,S_2,S_3,S_4,S_5,S_6,_i)
-#define RND_6(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_6,S_7,S_0,S_1,S_2,S_3,S_4,S_5,_i)
-#define RND_5(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_5,S_6,S_7,S_0,S_1,S_2,S_3,S_4,_i)
-#define RND_4(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_4,S_5,S_6,S_7,S_0,S_1,S_2,S_3,_i)
-#define RND_3(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_3,S_4,S_5,S_6,S_7,S_0,S_1,S_2,_i)
-#define RND_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_2,S_3,S_4,S_5,S_6,S_7,S_0,S_1,_i)
-#define RND_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_X(S_1,S_2,S_3,S_4,S_5,S_6,S_7,S_0,_i)
-
-
-#define RND_0_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_1_3(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i)
-#define RND_7_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_1_3(S_7,S_0,S_1,S_2,S_3,S_4,S_5,S_6,_i)
-#define RND_6_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_1_3(S_6,S_7,S_0,S_1,S_2,S_3,S_4,S_5,_i)
-#define RND_5_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_1_3(S_5,S_6,S_7,S_0,S_1,S_2,S_3,S_4,_i)
-#define RND_4_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_1_3(S_4,S_5,S_6,S_7,S_0,S_1,S_2,S_3,_i)
-#define RND_3_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_1_3(S_3,S_4,S_5,S_6,S_7,S_0,S_1,S_2,_i)
-#define RND_2_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_1_3(S_2,S_3,S_4,S_5,S_6,S_7,S_0,S_1,_i)
-#define RND_1_0(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_1_3(S_1,S_2,S_3,S_4,S_5,S_6,S_7,S_0,_i)
-
-#define RND_0_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_4_6(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i)
-#define RND_7_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_4_6(S_7,S_0,S_1,S_2,S_3,S_4,S_5,S_6,_i)
-#define RND_6_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_4_6(S_6,S_7,S_0,S_1,S_2,S_3,S_4,S_5,_i)
-#define RND_5_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_4_6(S_5,S_6,S_7,S_0,S_1,S_2,S_3,S_4,_i)
-#define RND_4_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_4_6(S_4,S_5,S_6,S_7,S_0,S_1,S_2,S_3,_i)
-#define RND_3_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_4_6(S_3,S_4,S_5,S_6,S_7,S_0,S_1,S_2,_i)
-#define RND_2_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_4_6(S_2,S_3,S_4,S_5,S_6,S_7,S_0,S_1,_i)
-#define RND_1_1(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_4_6(S_1,S_2,S_3,S_4,S_5,S_6,S_7,S_0,_i)
-
-#define RND_0_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_7_8(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i)
-#define RND_7_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_7_8(S_7,S_0,S_1,S_2,S_3,S_4,S_5,S_6,_i)
-#define RND_6_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_7_8(S_6,S_7,S_0,S_1,S_2,S_3,S_4,S_5,_i)
-#define RND_5_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_7_8(S_5,S_6,S_7,S_0,S_1,S_2,S_3,S_4,_i)
-#define RND_4_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_7_8(S_4,S_5,S_6,S_7,S_0,S_1,S_2,S_3,_i)
-#define RND_3_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_7_8(S_3,S_4,S_5,S_6,S_7,S_0,S_1,S_2,_i)
-#define RND_2_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_7_8(S_2,S_3,S_4,S_5,S_6,S_7,S_0,S_1,_i)
-#define RND_1_2(S_0,S_1,S_2,S_3,S_4,S_5,S_6,S_7,_i) RND_7_8(S_1,S_2,S_3,S_4,S_5,S_6,S_7,S_0,_i)
-
-#define FOR(cnt, init, max, inc, loop)  \
-    __asm__ volatile("movl $"#init", %0\n\t"#loop":"::"m"(cnt):)
-#define END(cnt, init, max, inc, loop)  \
-    __asm__ volatile("addl $"#inc", %0\n\tcmpl $"#max", %0\n\tjle "#loop"\n\t":"=m"(cnt)::);
+    /* L2 = (((a>>>9) ^ a) >>> 11) ^ a */                             \
+    "xorl	%" #a ", " L2 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) + Ch(e,f,g) + Maj(a,b,c) */            \
+    "addl	" L3 ", %" #h "\n\t"                                  \
+    /* L2 = ((((a>>>9) ^ a) >>> 11) ^ a) >>> 2 */                     \
+    "rorl	$2, " L2 "\n\t"                                       \
+    /* L1 = d (e of next RND) */                                      \
+    "movl	%" #d ", " L1 "\n\t"                                  \
+    /* h = h + w_k + Sigma1(e) Sigma0(a) + Ch(e,f,g) + Maj(a,b,c) */  \
+    "addl	" L2 ", %" #h "\n\t"                                  \
+
+
+#define RND_ALL_0(a, b, c, d, e, f, g, h, i) \
+       _RND_ALL_0(a, b, c, d, e, f, g, h, i)
+#define RND_ALL_1(a, b, c, d, e, f, g, h, i) \
+       _RND_ALL_1(a, b, c, d, e, f, g, h, i)
+
+#define RND_ALL_4(a, b, c, d, e, f, g, h, i)   \
+        RND_ALL_0(a, b, c, d, e, f, g, h, i+0) \
+        RND_ALL_1(h, a, b, c, d, e, f, g, i+1) \
+        RND_ALL_0(g, h, a, b, c, d, e, f, i+2) \
+        RND_ALL_1(f, g, h, a, b, c, d, e, i+3)
 
 #endif  /* defined(HAVE_INTEL_AVX1) ||  defined(HAVE_INTEL_AVX2) */
